#include<sys/types.h>
#include<unistd.h>
#include<stdlib.h>
#include<string.h>
#include<stdio.h>

#include "trfs_e.h"

static int * fds_g ;
static char ** bufs_g ;
static int dv_g ;

ssize_t read_e( int fd, void * buf, size_t count ) {
  int i, res ;
  int j ;
  res = read( fds_g[0], bufs_g[0], count ) ;
  for (i=1; i<dv_g; i++ ) {
    res = read( fds_g[i], bufs_g[i], count ) ;
    for ( j=0; j<count; j++ ) {
       bufs_g[0][j] ^= bufs_g[i][j] ;
    }
  }
  memcpy( buf, bufs_g[0], count ) ;
  return res ;
}

ssize_t write_e( int fd, const void * buf, size_t count ) {
  int i, res ;
  int j ;
  char r ;
  
  memcpy( bufs_g[0], buf, count ) ;
  for (i=1; i<dv_g; i++ ) {
     for ( j=0; j<count; j++ ) {
         r = (char) random() ;
         bufs_g[i][j] = r ;
         bufs_g[0][j] ^= r ;
     }
     res = write( fds_g[i], bufs_g[i], count ) ;
  }
  res = write( fds_g[0], bufs_g[0], count ) ;
  return res ;

}

off_t lseek_e( int fildes, off_t offset, int  whence ) {
  int i, res ;
  for (i=0; i<dv_g; i++ ) res = lseek( fds_g[i], offset, whence ) ;
  return res ;
}

int open_e( const char * pathname, int flags, mode_t mode ) {
  int i, res  ;
  char * sbuf ;
  sbuf = (char *) malloc( (strlen(pathname)+3)*sizeof(char) ) ;
  for (i=0; i<dv_g; i++ ) {
    sprintf( sbuf, "%s.%d", pathname, i ) ;
    res = fds_g[i] = open( sbuf, flags, mode ) ;
    if ( res==-1 ) break ;
  }
  free(sbuf) ;
  return res ;
}

int close_e( int fd ) {
  int i ;
  int res ;
  for (i-0; i<dv_g; i++ ) res = close(fds_g[i]) ;
  return res ;
}

int ssio_init( int dv, int clust_sz ) {

  int i ;
  dv_g = dv ;
  fds_g =  (int * ) malloc( dv*sizeof(int)) ;
  bufs_g = (char **) malloc ( dv*sizeof(char *)) ;
  for ( i=0; i<dv; i++ ) 
     bufs_g[i] = (char *) malloc ( clust_sz * sizeof(char) ) ;

  return 0 ;

}

