
/*
 * branched from trfs, trivial filesystem,
 * to add encryption layer. should backport all
 * the good ideas :-)
 *
 * file layout:
 * superblock (zero-th block)
 * FAT (blocks 1 through FN)
 * data blocks
 * 
 * first fat entry points to root directory.
 *
 */


/*
#define LSEEK_E(a,b,c) lseek((a),(b),(c))
#define WRITE_E(a,b,c) write((a),(b),(c))
#define READ_E(a,b,c)  read((a),(b),(c))
#define OPEN_E(a,b,c)  open((a),(b),(c))
#define CLOSE_E(a)     close((a))
#define SSIO_INIT_E(a,b) ((void))
*/

#define LSEEK_E(a,b,c) lseek_e((a),(b),(c))
#define WRITE_E(a,b,c) write_e((a),(b),(c))
#define READ_E(a,b,c)  read_e((a),(b),(c))
#define OPEN_E(a,b,c)  open_e((a),(b),(c))
#define CLOSE_E(a)     close_e((a))
#define SSIO_INIT_E(a,b) ssio_init((a),(b))

#define N_SPLIT_D 1 

off_t lseek_e( int, off_t, int ) ;
ssize_t write_e( int, const void *, size_t ) ;
ssize_t read_e( int, void *, size_t ) ;
int open_e( const char *, int, mode_t ) ;
int close_e( int ) ;

int ssio_init( int, int ) ; 


extern struct superblock_s sb_g ;

#define CLUSTER_SIZE_D 256
#define TOTAL_CLUSTERS_D 1024

#define SUPERBLOCK_OFFSET 0
#define FAT_OFFSET 1

typedef int dirent_t ;

struct superblock_s {
   int cluster_size ; /* in bytes */
   int offset_mask ;
   int fat_n ;
   int fat_base ; /* in bytes */
   int root_directory ; /* cluster number */
   int backing_file ;
} ;

#define DIR_TYPE_NULL 0
#define DIR_TYPE_FILE 1
#define DIR_TYPE_DIR  2
#define DIR_TYPE_DEL  3
#define DIR_TYPE_SELF 4

#define MAX_NAME_LENGTH 20

struct dirent_s {
   int type ;  /* zero if empty */
   int cluster ;
   int length ;
   char name[MAX_NAME_LENGTH] ;
} ;


#define FAT_TYPE_FREE 0
#define FAT_TYPE_EOF  (-1)

struct fatent_s {
   int cluster ;
} ;

